unit dbconnect;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, IBConnection, Forms, Controls, Graphics, Dialogs,
  StdCtrls;

type

  { TForm2 }

  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    IBCPeople: TIBConnection;
    SQLQPeople: TSQLQuery;
    SQLTPeople: TSQLTransaction;
    procedure connectDB;
    procedure closeDB;
    procedure SelectDBData;
    procedure UpdateDBData;
    procedure InsertDBData;
    procedure DeleteUpdateDBData;
    procedure DSGVODeleteDBData;
    procedure loadDBData(strID : string);
    procedure PersonenSuche(strText : string);
  private

  public

  end;

var
  Form2: TForm2;

implementation

uses
  startprogramu;

procedure TForm2.connectDB;
begin
  IBCPeople.Hostname            := 'localhost';
  IBCPeople.UserName            := 'SYSDBA';
  IBCPeople.Password            := 'masterkey';
  IBCPeople.DatabaseName        := 'E:\SQL\AWTEST.fdb';
  IBCPeople.Transaction         := SQLTPeople;
  IBCPeople.Connected           := True;
  SQLQPeople.Database           := IBCPeople;
end;

procedure TForm2.closeDB;
begin
   SQLQPeople.ExecSQL;
   SQLTPeople.Commit;
   SQLQPeople.active            := false;
end;

procedure TForm2.SelectDBData;
var
    strID, strLastName, strFirstName, strTel, strMobile : string;
begin
   connectDB;
   SQLQPeople.SQL.Text := 'Select * From PERSONEN';
   SQLQPeople.Active := true;
   SQLQPeople.Open;

   Form1.EdtID.Text := SQLQPeople.FieldbyName('ID').AsString;
   Form1.EdtLastName.Text := SQLQPeople.FieldbyName('NAME').AsString;
   Form1.EdtFirstName.Text := SQLQPeople.FieldbyName('VORNAME').AsString;
   Form1.EdtTel.Text := SQLQPeople.FieldbyName('TEL').AsString;
   Form1.EdtMobile.Text := SQLQPeople.FieldbyName('MOBIL').AsString;

   Form1.LVPeople.clear;
   while not SQLQPeople.Eof do
     begin
        strID := SQLQPeople.FieldbyName('ID').AsString;
        strLastName := SQLQPeople.FieldbyName('NAME').AsString;
        strFirstName := SQLQPeople.FieldbyName('VORNAME').AsString;
        strTel := SQLQPeople.FieldbyName('TEL').AsString;
        strMobile := SQLQPeople.FieldbyName('MOBIL').AsString;

         Form1.AddToListViewPersonen(strID, strLastName, strFirstName, strTel, strMobile);
         SQLQPeople.next;
      end;
   closeDB;
end;


procedure TForm2.loadDBData(strID : string);
begin
   SQLQPeople.SQL.Text := 'Select * From PERSONEN where ID ='''+strID+''';';
   SQLQPeople.Active := true;
   Form1.EdtID.Text := SQLQPeople.FieldbyName('ID').AsString;
   Form1.EdtLastName.Text := SQLQPeople.FieldbyName('NAME').AsString;
   Form1.EdtFirstName.Text := SQLQPeople.FieldbyName('VORNAME').AsString;
   Form1.EdtTel.Text := SQLQPeople.FieldbyName('TEL').AsString;
   Form1.EdtMobile.Text := SQLQPeople.FieldbyName('MOBIL').AsString;
   closeDB;
end;

procedure TForm2.UpdateDBData;
var
  strID, strLastName, strFirstName, strTel, strMobile : string;
begin
  strID := Form1.EdtID.Text;
  strLastName := Form1.EdtLastName.Text;
  strFirstName := Form1.EdtFirstName.Text;
  strTel := Form1.EdtTel.Text;
  strMobile := Form1.EdtMobile.Text;

  connectDB;
  SQLQPeople.SQL.Text := 'Update PERSONEN SET ID = '''+strID+''', NAME = '''+strLastName+''', VORNAME = '''+strFirstName+''', TEL = '''+strTel+''', MOBIL = '''+strMobile+''' WHERE ID = '''+strID+'''';
  closeDB;
end;

procedure TForm2.InsertDBData;
var
  // Variablen deklaration
  intLastID : integer;
  strID, strLastName, strFirstName, strTel, strMobile : string;
begin
  // Last Insert ID abfragen
  connectDB;
  SQLQPeople.SQL.Text := 'SELECT MAX(ID) AS PID FROM PERSONEN';
  SQLQPeople.Active := true;
  SQLQPeople.Open;
  intLastID := SQLQPeople.FieldByName('PID').AsInteger;
  closeDB;

  //GUI Anpassung ID eintragen
  intLastID := intLastID+1;

  // intLastID zu String umformen und GUI aktualisieren.
  strID := IntToStr(intLastID);
  Form1.EdtID.Text := strID;

  // Editfelder Daten in String Variablen abspeichern
  strLastName := Form1.EdtLastName.Text;
  strFirstName := Form1.EdtFirstName.Text;
  strTel := Form1.EdtTel.Text;
  strMobile := Form1.EdtMobile.Text;

  // Datenbank Insert
  connectDB;
  SQLQPeople.SQL.Text := 'Insert INTO PERSONEN (ID, NAME, VORNAME, TEL, MOBIL) VALUES('''+strID+''', '''+strLastName+''', '''+strFirstName+''', '''+strTel+''', '''+strMobile+''')';
  closeDB;

  // GUI Anpassung Listeview Daten hinzufügen
  Form1.AddToListViewPersonen(strID, strLastName, strFirstName, strTel, strMobile);
end;

procedure TForm2.DeleteUpdateDBData;
begin

end;

procedure TForm2.DSGVODeleteDBData;
var
  strID : string;
begin
  strID := Form1.EdtID.Text;
  connectDB;
  SQLQPeople.SQL.Text := 'DELETE FROM PERSONEN WHERE ID = '''+strID+''';';
  Form1.LVPeople.selected.Delete;
  closeDB;
end;

procedure TForm2.PersonenSuche(strText : string);
var
   strSpalte, strID, strLastName, strFirstName, strTel, strMobile : string;
begin

   if Form1.CB1PersonenSearch.ItemIndex = 0 then
   begin
     strSpalte := 'ID';
   end;

   if Form1.CB1PersonenSearch.ItemIndex = 1 then
   begin
     strSpalte := 'NAME';
   end;

   if Form1.CB1PersonenSearch.ItemIndex = 2 then
   begin
     strSpalte := 'VORNAME';
   end;

   connectDB;
   SQLQPeople.SQL.Text := 'Select * From PERSONEN WHERE '+strSpalte+' LIKE '''+strText+''' ORDER BY ID';
   SQLQPeople.Active := true;
   SQLQPeople.Open;

   Form1.EdtID.Text := SQLQPeople.FieldbyName('ID').AsString;
   Form1.EdtLastName.Text := SQLQPeople.FieldbyName('NAME').AsString;
   Form1.EdtFirstName.Text := SQLQPeople.FieldbyName('VORNAME').AsString;
   Form1.EdtTel.Text := SQLQPeople.FieldbyName('TEL').AsString;
   Form1.EdtMobile.Text := SQLQPeople.FieldbyName('MOBIL').AsString;

   Form1.LVPeople.clear;
   while not SQLQPeople.Eof do
     begin
        strID := SQLQPeople.FieldbyName('ID').AsString;
        strLastName := SQLQPeople.FieldbyName('NAME').AsString;
        strFirstName := SQLQPeople.FieldbyName('VORNAME').AsString;
        strTel := SQLQPeople.FieldbyName('TEL').AsString;
        strMobile := SQLQPeople.FieldbyName('MOBIL').AsString;

         Form1.AddToListViewPersonen(strID, strLastName, strFirstName, strTel, strMobile);
         SQLQPeople.next;
      end;
   closeDB;
end;

{$R *.lfm}

end.

