unit startprogramu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  DividerBevel, dbconnect;

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnPeopleSave: TButton;
    BtnPeopleDelete: TButton;
    BtnPeopleNew: TButton;
    BtnPersonenSearch: TButton;
    BtnFilterDelete: TButton;
    CB1PersonenSearch: TComboBox;
    DB1PeopleView: TDividerBevel;
    DB2PeopleEdit: TDividerBevel;
    EdtPersonenSearch: TEdit;
    EdtTel: TEdit;
    EdtMobile: TEdit;
    EdtID: TEdit;
    EdtLastName: TEdit;
    EdtFirstName: TEdit;
    GBPeople: TGroupBox;
    LBLShowID: TLabel;
    LblID: TLabel;
    LblLastName: TLabel;
    LblFirstName: TLabel;
    LblMobile: TLabel;
    LblFestnetz: TLabel;
    LVPeople: TListView;
    PC1People: TPageControl;
    TabSheet1: TTabSheet;
    procedure BtnFilterDeleteClick(Sender: TObject);
    procedure BtnPeopleDeleteClick(Sender: TObject);
    procedure BtnPeopleNewClick(Sender: TObject);
    procedure BtnPeopleSaveClick(Sender: TObject);
    procedure BtnPersonenSearchClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LVPeopleClick(Sender: TObject);
    procedure SetProjectVarSettings;
    procedure SelectFormDBData;
    procedure AddToListViewPersonen(ID, LastName, FirstName, Tel, Mobilnum : String);
  private

  public

  end;

var
  Form1: TForm1;
  isInsertOrUpdate : integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.BtnPeopleNewClick(Sender: TObject);
begin
  // Variable InsertOrUpdate setzen auf Insert
  isInsertOrUpdate := 0;

  // Alle Editfelder leeren.
  EdtID.Text := '';
  EdtLastName.Text := '';
  EdtFirstName.Text := '';
  EdtTel.Text := '';
  EdtMobile.Text := '';
end;

procedure TForm1.BtnPeopleSaveClick(Sender: TObject);
begin
  {* Prüfen ob ein Update oder
   * ein Insert ausgeführt werden soll.
   *}
  if(isInsertOrUpdate = 1) then
  begin
    // Update ausführen
    Form2.UpdateDBData;
  end
  else
  begin
    // Insert ausführen
    Form2.InsertDBData;
    isInsertOrUpdate := 1;
  end;
end;

procedure TForm1.BtnPersonenSearchClick(Sender: TObject);
begin
  Form2.PersonenSuche(Form1.EdtPersonenSearch.Text);
end;


procedure TForm1.FormShow(Sender: TObject);
begin
  // Projekt Variablen setzen.
  SetProjectVarSettings;
  // Projekt DB Daten laden
  Form2.SelectDBData;
end;

procedure TForm1.LVPeopleClick(Sender: TObject);
var
  strID : string;
begin

  if LVPeople.Selected <> nil then
  begin
    strID := LVPeople.Selected.caption;
    Form2.loadDBData(strID);
  end
  else
  begin
     // Wenn keine Reihe ausgewählt ist mache nichts.
  end;

end;


procedure TForm1.BtnPeopleDeleteClick(Sender: TObject);
begin
  //Procedure UpdateDelete ausführen.
  Form2.DSGVODeleteDBData;
end;

procedure TForm1.BtnFilterDeleteClick(Sender: TObject);
begin
  // Filterlöschen
   Form2.SelectDBData;
end;

procedure TForm1.SetProjectVarSettings;
begin
  {* isInsertOrUpdate = 1 = Update ist gesetzt.
   * isInsertOrUpdate = 01 = Insert ist gesetzt.
   *}
  isInsertOrUpdate := 1;
end;

procedure TForm1.SelectFormDBData;
Begin
  Form2.SelectDBData;
end;

procedure TForm1.AddToListViewPersonen(ID, LastName, FirstName, Tel, Mobilnum : string);
var
  item : TListItem;
begin
  item := Form1.LVPeople.Items.Add;
  item.caption := ID;
  item.subItems.Add(LastName);
  item.subItems.Add(FirstName);
  item.subItems.Add(Tel);
  item.subItems.Add(Mobilnum);
end;
end.

